// seedfill.h header file

#ifndef SEEDFILL_H
#define SEEDFILL_H

typedef struct {		/* window: a discrete 2-D rectangle */
    int x0, y0;			/* xmin and ymin */
    int x1, y1;			/* xmax and ymax (inclusive) */
} Window;

typedef int Pixel;		/* 1-channel frame buffer assumed */

//Pixel pixelread();

typedef struct {short y, xl, xr, dy;} Segment;
/*
 * Filled horizontal segment of scanline y for xl<=x<=xr.
 * Parent segment was on line y-dy.  dy=1 or -1
 */

#define MAX 10000		/* max depth of stack */

#define PUSH(Y, XL, XR, DY)	/* push new segment on stack */ \
    if (sp<stack+MAX && Y+(DY)>=win->y0 && Y+(DY)<=win->y1) \
    {sp->y = Y; sp->xl = XL; sp->xr = XR; sp->dy = DY; sp++;}

#define POP(Y, XL, XR, DY)	/* pop segment off stack */ \
    {sp--; Y = sp->y+(DY = sp->dy); XL = sp->xl; XR = sp->xr;}

/* procedure declarations */

long fill(x, y, win, nv, width, blobArray, fillSpace); // this has threshold
int pixelread( int x, int y, int width, int *blobArray );
long pixelwrite( int x, int y, int nv, int width, int *blobArray, int *fillSpace);
long binary_fill(x, y, win, nv, width, blobArray, fillSpace); // this is binary
//int pixelread( int x, int y );
//int pixelwrite( int x, int y, int nv );

#endif // SEEDFILL_H